using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;
using System.Threading;

namespace mecha2
{
    public partial class Form1 : Form
    {
        SerialPort bluetooth = new SerialPort("COM4");       
        byte[] message = new byte[1];
        bool voor = true;
        bool fan = false;
        bool sirene = false;
        bool connected = false;
        bool stopped = false;

        byte stoppen = (byte)0x00;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                bluetooth.BaudRate = 9600;
                bluetooth.DataBits = 8;
                bluetooth.StopBits = StopBits.One ;
                bluetooth.Parity = Parity.None;
                bluetooth.Open();
                Thread.Sleep(1000);
                connected = true;
            }
            catch (IOException exc)
            {
                lblIOException.ForeColor = Color.Red;
                lblIOException.Text = exc.Message;
            }
        }

        #region Controller

        private void stop_Click(object sender, EventArgs e)
        {
            if (connected)
            {
                if(sirene)
                    message[0] = (byte)0x04;
                else if (fan)
                    message[0] = (byte)0x08;
                else if (fan && sirene)
                    message[0] = (byte)0x0C;
                else 
                    message[0] = stoppen;
                bluetooth.Write(message, 0, 1);
                stopped = true;
            }
        }
        private void links_Click(object sender, EventArgs e)
        {
            if (connected)
            {
                if (voor)
                {
                    if (sirene)
                        message[0] = (byte)0x24;
                    else
                        message[0] = (byte)0x20;
                }
                else
                {
                    if (sirene)
                        message[0] = (byte)0x14;
                    else
                        message[0] = (byte)0x10;
                }
                bluetooth.Write(message, 0, 1);
                stopped = false;
                lblIOException.Text = message[0].ToString();
            }
        }
        private void rechts_Click(object sender, EventArgs e)
        {
            if (connected)
            {
                if (voor)
                {
                    if (sirene)
                        message[0] = (byte)0x84;
                    else
                        message[0] = (byte)0x80;
                }
                else
                {
                    if (sirene)
                        message[0] = (byte)0x44;
                    else
                        message[0] = (byte)0x40;
                }
                bluetooth.Write(message, 0, 1);
                stopped = false;
                lblIOException.Text = message[0].ToString();
            }
        }
        private void achteruit_Click(object sender, EventArgs e)
        {
            if (connected)
            {
                if (sirene)
                    message[0] = (byte)0x54;
                else
                    message[0] = (byte)0x50;
                bluetooth.Write(message, 0, 1);
                voor = false;
                stopped = false;
                }
                lblIOException.Text = message[0].ToString();
        }
        private void vooruit_Click(object sender, EventArgs e)
        {
            if (connected)
            {
                if (sirene)
                    message[0] = (byte)0xA4;
                else
                    message[0] = (byte)0xA0;
                bluetooth.Write(message, 0, 1);
                voor = true;
                stopped = false;
            }
            lblIOException.Text = message[0].ToString();
        }
        #endregion

        #region Fan

        private void rdbFanAan_CheckedChanged(object sender, EventArgs e)
        {
            if (connected && stopped)
            {
                message[0] = (byte)0x08;
                bluetooth.Write(message, 0, 1);
                fan = true;
            }
        }
        private void rdbFanUit_CheckedChanged(object sender, EventArgs e)
        {
            if (connected && stopped)
            {
                message[0] = (byte)0x00;
                bluetooth.Write(message, 0, 1);
                fan = false;
            }
        }

        #endregion

        #region Sirene

        private void rdbSireneAan_CheckedChanged(object sender, EventArgs e)
        {
            sirene = true;
        }
        private void rdbSireneUit_CheckedChanged(object sender, EventArgs e)
        {
            sirene = false;
        }
       #endregion

    }
}